//       


#include <evo.h>
#include "resources.h"

#define SPRITES_ALL	11 //20    130000t, 17  100000t  


#define WRONGY 0 /*  exist==0,    exist */

#define XTYPE u16
#define DXTYPE i16
#define UTYPE u32 /*  dist  SQR(BALLSIZE) */
#define ITYPE i32 /*  p */
#define SHIFTCOORDS 7

#define SCRSHIFTX 16
#define SCRSHIFTY 16
#define LEFTMARGIN (((XTYPE)SCRSHIFTX)<<SHIFTCOORDS) /*    -BALLSIZE     x-dx*/
#define RIGHTMARGIN (((XTYPE)(320+SCRSHIFTX-16))<<SHIFTCOORDS)
#define TOPMARGIN (((XTYPE)TOP)<<SHIFTCOORDS) /*    -BALLSIZE     y-dy*/
#define BOTTOMMARGIN (((XTYPE)(200+SCRSHIFTY-16))<<SHIFTCOORDS)
#define RNDLEFTMARGIN (LEFTMARGIN+(16<<SHIFTCOORDS))
#define RNDRIGHTMARGIN (RIGHTMARGIN-(16<<SHIFTCOORDS))
#define RNDTOPMARGIN (TOPMARGIN+(16<<SHIFTCOORDS))
#define RNDBOTTOMMARGIN (BOTTOMMARGIN-(16<<SHIFTCOORDS))

//#define CHECKMAXSPEED
#define MAXSPEED (2<<SHIFTCOORDS)

#define ballsize 15
#define sqrhalfballsize (ballsize*ballsize/4)
#define BALLSIZE (ballsize<<SHIFTCOORDS)

#define BRIM 11
#define TOP (32+SCRSHIFTY)
#define BOTTOM (200+SCRSHIFTY)
#define LEFT (0+SCRSHIFTX)
#define RIGHT (320+SCRSHIFTX)
#define MIDX (160+SCRSHIFTX)
#define POCKETSIZE 24
#define CORNERSIZE 24
#define CORNERLEFT (LEFT+(CORNERSIZE-BRIM))
#define CORNERRIGHT (RIGHT-(CORNERSIZE-BRIM))
#define CORNERTOP (TOP+(CORNERSIZE-BRIM))
#define CORNERBOTTOM (BOTTOM-(CORNERSIZE-BRIM))
#define TOPY (TOP+BRIM)
#define TOPLEFTMINX (LEFT+CORNERSIZE)
#define TOPLEFTMAXX (MIDX-(POCKETSIZE/2))
#define TOPRIGHTMINX (MIDX+(POCKETSIZE/2))
#define TOPRIGHTMAXX (RIGHT-CORNERSIZE)
#define BOTTOMY (BOTTOM-BRIM)
#define BOTTOMLEFTMINX TOPLEFTMINX
#define BOTTOMLEFTMAXX TOPLEFTMAXX
#define BOTTOMRIGHTMINX TOPRIGHTMINX
#define BOTTOMRIGHTMAXX TOPRIGHTMAXX
#define LEFTX (LEFT+BRIM)
#define LEFTMINY (TOP+CORNERSIZE)
#define LEFTMAXY (BOTTOM-CORNERSIZE)
#define RIGHTX (RIGHT-BRIM)
#define RIGHTMINY LEFTMINY
#define RIGHTMAXY LEFTMAXY



//       ,       ,   
// : dx=-dxold
// : dy=-dyold
//       : dx=dyold, dy=dxold
//       : dx=-dyold, dy=-dxold
//  (   , ..  ):    

//  = xleft,ytop =      bounding box  SCRSHIFT
//    SCRSHIFT
// x,y (), ytop, ybottom, xleft, xright

//     [x,y],    

//     ytop<TOPY (    ,    ):

//    : (x>TOPLEFTMINX) && (x<TOPLEFTMAXX) //&& (ytop<TOPY)
//     : (x<=TOPLEFTMINX) && ((y-x-(ballsize*7/10))<(TOP-CORNERLEFT))
//    : (x>TOPRIGHTMINX) && (x<TOPRIGHTMAXX) //&& (ytop<TOPY)
//     : (x>=TOPRIGHTMAXX) && ((y+x-(ballsize*7/10))<(TOP+CORNERRIGHT))
//if (y<TOPY) {
//     : ((TOPLEFTMAXX-xleft)<ballsize) //&& (y<TOPY)
//     : ((xright-TOPRIGHTMINX)<ballsize) //&& (y<TOPY)
//} else {
//     : ((sqr(x-TOPLEFTMAXX)+sqr(y-TOPY))<sqrhalfballsize)
//     : ((sqr(x-TOPRIGHTMINX)+sqr(y-TOPY))<sqrhalfballsize)
//      : ((sqr(x-TOPLEFTMINX)+sqr(y-TOPY))<sqrhalfballsize)
//      : ((sqr(x-TOPRIGHTMAXX)+sqr(y-TOPY))<sqrhalfballsize)
//}

//     ybottom>BOTTOMY (    ,    ):

//    : (x>BOTTOMLEFTMINX) && (x<BOTTOMLEFTMAXX) //&& (ybottom>BOTTOMY)
//     : (x<=BOTTOMLEFTMINX) && ((y+x+(ballsize*7/10))>(BOTTOM+CORNERLEFT))
//    : (x>BOTTOMRIGHTMINX) && (x<BOTTOMRIGHTMAXX) //&& (ybottom>BOTTOMY)
//     : (x>=BOTTOMRIGHTMAXX) && ((y-x+(ballsize*7/10))>(BOTTOM-CORNERRIGHT))
//if (y>BOTTOMY) {
//     : ((BOTTOMLEFTMAXX-xleft)<ballsize) //&& (y>BOTTOMY)
//     : ((xright-BOTTOMRIGHTMINX)<ballsize) //&& (y>BOTTOMY)
//} else {
//     : ((sqr(x-BOTTOMLEFTMAXX)+sqr(y-BOTTOMY))<sqrhalfballsize)
//     : ((sqr(x-BOTTOMRIGHTMINX)+sqr(y-BOTTOMY))<sqrhalfballsize)
//      : ((sqr(x-BOTTOMLEFTMINX)+sqr(y-BOTTOMY))<sqrhalfballsize)
//      : ((sqr(x-BOTTOMRIGHTMAXX)+sqr(y-BOTTOMY))<sqrhalfballsize)
//}

//     xleft<LEFTX (    ,    )

//  : (y>LEFTMINY) && (y<LEFTMAXY) //&& (xleft<LEFTX)
//     : (y<=LEFTMINY) && ((y-x+(ballsize*7/10))>(CORNERTOP-LEFT))
//     : (y>=LEFTMAXY) && ((y+x-(ballsize*7/10))<(CORNERBOTTOM+LEFT))
//      : ((sqr(x-LEFTX)+sqr(y-LEFTMINY))<sqrhalfballsize)
//      : ((sqr(x-LEFTX)+sqr(y-LEFTMAXY))<sqrhalfballsize)

//     xright>RIGHTX (    ,    )

//  : (y>RIGHTMINY) && (y<RIGHTMAXY) //&& (xright>RIGHTX)
//     : (y<=RIGHTMINY) && ((y+x+(ballsize*7/10))>(CORNERTOP+RIGHT))
//     : (y>=RIGHTMAXY) && ((y-x-(ballsize*7/10))<(CORNERBOTTOM-RIGHT))
//      : ((sqr(x-RIGHTX)+sqr(y-RIGHTMINY))<sqrhalfballsize)
//      : ((sqr(x-RIGHTX)+sqr(y-RIGHTMAXY))<sqrhalfballsize)



// 

struct spriteStruct {
	XTYPE x,y;	//
	DXTYPE dx,dy;	// 
	u8 color;
	u8 exist;
	u8 wallcollided;
};

// 

struct spriteStruct spriteList[SPRITES_ALL];

u8 spritezones[SPRITES_ALL*2];

#define ZONESHIFT 4
#define XZONES ((320>>ZONESHIFT)+1)
#define YZONES ((200>>ZONESHIFT)+1)
i8 ballsinzone[(YZONES+1)<<8];

u8 collided[SPRITES_ALL][SPRITES_ALL];
//0 -  
//>0 - ,  ,   

volatile u8 i,j;
volatile XTYPE x,y,xleft,xright,ytop,ybottom;
volatile u8 movingballs;
static u8 key;
static u8 keys[40];
static u8 joy;

#define ABS(x) (((x)<0)?(-x):(x))
#define sqr(x) ((x)*(x))
#define SQR(x) ((ITYPE)((UTYPE)(x)*(UTYPE)(x)))

static u8 tsqr[256];

#define DOTPRODUCT(x1,y1,x2,y2) ((x1)*(x2)+(y1)*(y2))

DXTYPE dotproduct(DXTYPE x1,DXTYPE y1,DXTYPE x2,DXTYPE y2)
{
	return(x1*x2+y1*y2);
}

unsigned int lsqrt(unsigned long arg){
char count=16;
unsigned long res=0,tmp=0;
	if(arg!=0){ 
		if(!(arg&0xFF000000)){arg<<=8;count-=4;}


		res=1;
		while((tmp<1)&&(count)){
			count--;
			if(arg&0x80000000UL)tmp|=2;
			if(arg&0x40000000UL)tmp|=1;

			arg<<=2;


		};//  1-
		tmp--;
		for(count;count;count--){
			tmp<<=2;
			res<<=1;

			if(arg&0x80000000UL)tmp|=2;
			if(arg&0x40000000UL)tmp|=1;
			arg<<=2;

			if( tmp>=((res<<1)|1)){
				tmp-=((res<<1)|1);
				res|=1;
			}
			
		}
	}
	return (unsigned int)res;
} 

static XTYPE xshow=BOTTOMLEFTMINX,yshow=BOTTOMY;

static u8 output_x,output_y;
static char tscore[7]="012345";

//       
// ,   '\n'  
void put_char(u8 n)
{
	if(n>=' '&&n<='Z') draw_tile(output_x,output_y,n-' ');

	++output_x;

	if(output_x==39||n=='\n')
	{
		output_x=1;
		
		++output_y;
		
		if(output_y==24) output_y=1;
	}
}

//  
void put_str(u8* str)
{
	u8 i;

	while(1)
	{
		i=*str++;

		if(!i) break;

		put_char(i);
	}
}


void prnum(u8 y,u8 x,u16 hiscore)
{
	select_image(IMG_FONT);
	tscore[0]='0'+hiscore/100000;
	tscore[1]='0'+(hiscore%100000)/10000;
	tscore[2]='0'+(hiscore%10000)/1000;
	tscore[3]='0'+(hiscore%1000)/100;
	tscore[4]='0'+(hiscore%100)/10;
	tscore[5]='0'+(hiscore%10);
	output_x=x;
	output_y=y;
	put_str(tscore);
}

/*
void przones(u8 y,u8 x)
{
	u8 i;
	output_x=x;
	output_y=y;
	select_image(IMG_FONT);
	for (i=1;i<ZONES;i++) {
		put_char('0'+ballsinzone[i]);
		put_char(' ');
	}
}
*/


void draw_sprites() {
		i=(SPRITES_ALL-1);
		//for(i=(SPRITES_ALL-1);i!=(u8)(-1);--i) {
		//do {
			//if (spriteList[i].exist) {
			//i&3      
			//i&4 =    X

			//tmpx=spriteList[i].x;
			//tmpxscr=(tmpx>>(SHIFTCOORDS+1)); //>>SHIFTCOORDS   
			//j=tmpxscr>>8; //  
/*			set_sprite(j++,
					tmpxscr-(SCRSHIFTX>>1),
					(spriteList[i].y>>SHIFTCOORDS)-SCRSHIFTY,
					spriteList[i].color|((tmpx&(1<<SHIFTCOORDS))?16:0));*/
			_asm
			ld	a,(#_i+0)
			ld	e,a
9998500$: // 
			//ld	a,(#_i+0)
			//ld	e,a
			ld a,e
			add	a,a
			add	a,a
			add	a,e
			add	a,a
			add	a,e
			ld hl,#_spriteList+9
			add	a,l //#<_spriteList
			ld	l,a
			ld	a,h //#>_spriteList
			adc	a,#0x00
			ld	h,a
			ld a,(hl) //exist
			or a
			jr z,9998501$ //    
			push de
			dec hl
			ld c,(hl) //color
			dec hl
			dec hl
			dec hl
			dec hl
			dec hl
			ld a,(hl) //Y
			dec hl
			ld e,(hl) //y
			rl e
			rla
			add	a,#0xF0
			ld d,a //d=(spriteList[i].y>>SHIFTCOORDS)-SCRSHIFTY
			dec hl
			ld a,(hl) //X
			add	a,#0xF8
			ld e,a //e=tmpxscr-(SCRSHIFTX>>1)
			dec hl
			ld a,(hl) //x
			rla
			sbc a,a
			and #0x10
			or	a,c //color
			ld	c,a
			ld	b,#0x00
			push bc //spriteList[i].color|((tmpx&(1<<SHIFTCOORDS))?4:0)
			push de //d=(spriteList[i].y>>SHIFTCOORDS)-SCRSHIFTY //e=tmpxscr-(SCRSHIFTX>>1)
			ld	hl,#_j + 0
			ld	a,(hl)
			inc (hl)
			push	af //j++
			inc	sp
			call	_set_sprite
			pop	af
			pop	af
			inc	sp
			pop de
9998501$: //    
			dec e
			jp p,9998500$ // 
			_endasm;

			//}
//		}while((--i)!=(u8)(-1));
}


void moveballs() {
	static u8 xzone,yzone;
	static u8* addr;
	static u8* spritezonesaddr;
	static u8 slowphase;
	static u16 tmpxscr;
	static XTYPE tmpx,tmpy,tmpnewx,tmpnewy;
	static XTYPE tmpxmin,tmpymin;
	static DXTYPE nx,ny,px,py;
	static DXTYPE dxold,dyold;
	static i8 p; //DXTYPE //ITYPE
	static UTYPE dist;
	static XTYPE sqrdy; //UTYPE     ,   
	static u8 comparisons;
			
			movingballs=0;
			slowphase++;
			//
#define RESTOREX tmpnewx=tmpx;
#define RESTOREY tmpnewy=tmpy;
#define RESTORECOORDS /*RESTOREX;RESTOREY;*/
			for(i=0;i<SPRITES_ALL;++i) if (spriteList[i].exist)
			{
				tmpx=spriteList[i].x;
				tmpy=spriteList[i].y;

				tmpnewx=tmpx+spriteList[i].dx;
				if (((tmpnewx>=RIGHTMARGIN)/*&&(spriteList[i].dx>=0)*/)
				|| ((tmpnewx<LEFTMARGIN)/*&&(spriteList[i].dx<0)*/))
				{
					spriteList[i].dx=-spriteList[i].dx;
					tmpnewx=tmpx+spriteList[i].dx;
					//TODO ,   ,      
					tmpnewy=WRONGY;
					spriteList[i].exist=0;
				}
				tmpnewy=tmpy+spriteList[i].dy;
				if (((tmpnewy>=BOTTOMMARGIN)/*&&(spriteList[i].dy>=0)*/)
				|| ((tmpnewy<TOPMARGIN)/*&&(spriteList[i].dy<0)*/))
				{
					spriteList[i].dy=-spriteList[i].dy;
					tmpnewy=tmpy+spriteList[i].dy;
					//TODO ,   ,      
					tmpnewy=WRONGY;
					spriteList[i].exist=0;
				}

			//}
			//   

			//for(i=0;i<SPRITES_ALL;++i)
			{
				if ((spriteList[i].dx)||(spriteList[i].dy)) {
					movingballs=1;
					if (((slowphase-i)&15)==0) {
						spriteList[i].dx=spriteList[i].dx*15/16; //    
						spriteList[i].dy=spriteList[i].dy*15/16; //    
						if ( (ABS(spriteList[i].dx) < 12)
						  && (ABS(spriteList[i].dy) < 12) ) {
							spriteList[i].dx=0;
							spriteList[i].dy=0;
						}
					}
				}
			}

			// 
			//for(i=0;i<SPRITES_ALL;++i) {

//       ,       ,   
// : dx=-dxold
// : dy=-dyold
//       : dx=dyold, dy=dxold
//       : dx=-dyold, dy=-dxold
//  (   , ..  ): TODO    

//  = xleft,ytop =      bounding box  SCRSHIFT
//    SCRSHIFT
// x,y (), ytop, ybottom, xleft, xright
				//xleft=(XTYPE)(tmpx+SCRSHIFTX)>>SHIFTCOORDS;
				//xright=xleft+ballsize;
				//x=xleft+(ballsize/2);
				//ytop=(XTYPE)(tmpy+SCRSHIFTY)>>SHIFTCOORDS;
				//ybottom=ytop+ballsize;
				//y=ytop+(ballsize/2);
				_asm
				ld hl,(#_moveballs_tmpx_1_1+0)
				ld bc,#0x0010 //SCRSHIFTX
				add hl,bc
				add hl,hl
				ld l,h
				ld h,b
				rl h
				ld (#_xleft+0),hl
				ex de,hl
				ld hl,(#_moveballs_tmpy_1_1+0)
				add hl,bc //SCRSHIFTY==SCRSHIFTX
				add hl,hl
				ld l,h
				ld h,b
				rl h
				ld (#_ytop+0),hl
				ld c,#0x07 //ballsize/2
				add hl,bc
				ld (#_y+0),hl
				ex de,hl
				add hl,bc
				ld (#_x+0),hl
				inc c //ld c,#0x08 //ballsize-(ballsize/2)
				add hl,bc
				ld (#_xright+0),hl
				ex de,hl
				add hl,bc
				ld (#_ybottom+0),hl
				_endasm;

				dxold=spriteList[i].dx;
				dyold=spriteList[i].dy;

#define WALLCOLLIDED /*spriteList[i].wallcollided=2;*/
//     [x,y],    

//     ytop<TOPY (    ,    ):
				if (ytop<TOPY) {
//    : (x>TOPLEFTMINX) && (x<TOPLEFTMAXX) //&& (ytop<TOPY)
					if ( (x>TOPLEFTMINX) && (x<TOPLEFTMAXX) ) {
						spriteList[i].dy=-dyold;
						//RESTOREY;
						tmpnewy=((XTYPE)TOPY<<SHIFTCOORDS);
					}
//     : (x<=TOPLEFTMINX) && ((y-x-(ballsize*7/10))<(TOP-CORNERLEFT))
					else if ( (x<=TOPLEFTMINX) ) {
						if ( (y<(x+TOP-CORNERLEFT+(ballsize*7/10))) && (-dyold>-dxold) ) {
							spriteList[i].dx=dyold;
							spriteList[i].dy=dxold;
							RESTORECOORDS;
						}
					}
//    : (x>TOPRIGHTMINX) && (x<TOPRIGHTMAXX) //&& (ytop<TOPY)
					else if ( (x>TOPRIGHTMINX) && (x<TOPRIGHTMAXX) ) {
						spriteList[i].dy=-dyold;
						//RESTOREY;
						tmpnewy=((XTYPE)TOPY<<SHIFTCOORDS);
					}
//     : (x>=TOPRIGHTMAXX) && ((y+x-(ballsize*7/10))<(TOP+CORNERRIGHT))
					else if ( (x>=TOPRIGHTMAXX) ) {
						if ( ((y+x)<(TOP+CORNERRIGHT+(ballsize*7/10))) && (-dyold>dxold) ) {
							spriteList[i].dx=-dyold;
							spriteList[i].dy=-dxold;
							RESTORECOORDS;
						}
					}
					else {
//if (y<TOPY) {
						if (y<TOPY) {
//     : ((TOPLEFTMAXX-xleft)<ballsize) //&& (y<TOPY)
							if ((TOPLEFTMAXX-xleft)<ballsize) {
								spriteList[i].dx=-dxold;
								RESTOREX;
							}
//     : ((xright-TOPRIGHTMINX)<ballsize) //&& (y<TOPY)
							else if ((xright-TOPRIGHTMINX)<ballsize) {
								spriteList[i].dx=-dxold;
								RESTOREX;
							}
//} else {
						} else {
						//if(!spriteList[i].wallcollided) {
							sqrdy=sqrhalfballsize-sqr((DXTYPE)y-TOPY);
//     : ((sqr(x-TOPLEFTMAXX)+sqr(y-TOPY))<sqrhalfballsize)
							if ((x>TOPLEFTMAXX) && ((sqr(x-TOPLEFTMAXX))<sqrdy)) { //x>
								spriteList[i].dx=ABS(dyold); //-dyold
								spriteList[i].dy=ABS(dxold); //-dxold
								RESTORECOORDS;
								WALLCOLLIDED;
							}
//     : ((sqr(x-TOPRIGHTMINX)+sqr(y-TOPY))<sqrhalfballsize)
							else if ((x<TOPRIGHTMINX) && ((sqr(TOPRIGHTMINX-x))<sqrdy)) { //x<
								spriteList[i].dx=-ABS(dyold); //dyold
								spriteList[i].dy=ABS(dxold);
								RESTORECOORDS;
								WALLCOLLIDED;
							}
//      : ((sqr(x-TOPLEFTMINX)+sqr(y-TOPY))<sqrhalfballsize)
							else if ((x<TOPLEFTMINX) && ((sqr(TOPLEFTMINX-x))<sqrdy) && (dyold<0)) { //x<
								spriteList[i].dx=dyold;
								spriteList[i].dy=dxold;
								RESTORECOORDS;
								WALLCOLLIDED;
							}
//      : ((sqr(x-TOPRIGHTMINX)+sqr(y-TOPY))<sqrhalfballsize)
							else if ((x>TOPRIGHTMAXX) && ((sqr(x-TOPRIGHTMAXX))<sqrdy) && (dyold<0)) { //x>
								spriteList[i].dx=-dyold;
								spriteList[i].dy=-dxold;
								RESTORECOORDS;
								WALLCOLLIDED;
							}
//}
						} //else spriteList[i].wallcollided--;
					}
				}

/*
					if ( (y<(x+TOP-CORNERLEFT+(ballsize*7/10))) ) {
						spriteList[i].dx=dyold;
						spriteList[i].dy=dxold;
					}
					if ( ((y+x)<(TOP+CORNERRIGHT+(ballsize*7/10))) ) {
								spriteList[i].color=(spriteList[i].color+1)&3;
						spriteList[i].dx=-dyold;
						spriteList[i].dy=-dxold;
					}
*/

//     ybottom>BOTTOMY (    ,    ):
				if (ybottom>BOTTOMY) {
//    : (x>BOTTOMLEFTMINX) && (x<BOTTOMLEFTMAXX) //&& (ybottom>BOTTOMY)
					if ( (x>BOTTOMLEFTMINX) && (x<BOTTOMLEFTMAXX) ) {
						spriteList[i].dy=-dyold;
						//RESTOREY;
						tmpnewy=((XTYPE)BOTTOMY<<SHIFTCOORDS)-BALLSIZE;
					}
//     : (x<=BOTTOMLEFTMINX) && ((y+x+(ballsize*7/10))>(BOTTOM+CORNERLEFT))
					else if ( (x<=BOTTOMLEFTMINX) ) {
						if ( ((y+x)>(BOTTOM+CORNERLEFT-(ballsize*7/10))) && (dyold>-dxold) ) {
							spriteList[i].dx=-dyold;
							spriteList[i].dy=-dxold;
							//RESTORECOORDS;
						}
					}
//    : (x>BOTTOMRIGHTMINX) && (x<BOTTOMRIGHTMAXX) //&& (ybottom>BOTTOMY)
					else if ( (x>BOTTOMRIGHTMINX) && (x<BOTTOMRIGHTMAXX) ) {
						spriteList[i].dy=-dyold;
						//RESTOREY;
						tmpnewy=((XTYPE)BOTTOMY<<SHIFTCOORDS)-BALLSIZE;
					}
//     : (x>=BOTTOMRIGHTMAXX) && ((y-x+(ballsize*7/10))>(BOTTOM-CORNERRIGHT))
					else if ( (x>=BOTTOMRIGHTMAXX) ) {
						if ( (y>(x+BOTTOM-CORNERRIGHT-(ballsize*7/10))) && (dyold>dxold) ) {
							spriteList[i].dx=dyold;
							spriteList[i].dy=dxold;
							//RESTORECOORDS;
						}
					}
//if (y>BOTTOMY) {
						if (y>BOTTOMY) {
//     : ((BOTTOMLEFTMAXX-xleft)<ballsize) //&& (y>BOTTOMY)
							if ((BOTTOMLEFTMAXX-xleft)<ballsize) { //xleft<
								spriteList[i].dx=-dxold;
								RESTOREX;
							}
//     : ((xright-BOTTOMRIGHTMINX)<ballsize) //&& (y>BOTTOMY)
							else if ((xright-BOTTOMRIGHTMINX)<ballsize) { //xright>
								spriteList[i].dx=-dxold;
								RESTOREX;
							}
//} else {
						} else {
							sqrdy=sqrhalfballsize-sqr(BOTTOMY-(DXTYPE)y);
//     : ((sqr(x-BOTTOMLEFTMAXX)+sqr(y-BOTTOMY))<sqrhalfballsize)
							if ((x>BOTTOMLEFTMAXX) && ((sqr(x-BOTTOMLEFTMAXX))<sqrdy)) { //x>
								//xshow=dxold;
								//yshow=dyold;
								spriteList[i].dx=ABS(dyold);
								spriteList[i].dy=-ABS(dxold);
								RESTORECOORDS;
								WALLCOLLIDED;
							}
//     : ((sqr(x-BOTTOMRIGHTMINX)+sqr(y-BOTTOMY))<sqrhalfballsize)
							else if ((x<BOTTOMRIGHTMINX) && ((sqr(BOTTOMRIGHTMINX-x))<sqrdy)) { //x<
								//xshow=x;
								//yshow=y;
								spriteList[i].dx=-ABS(dyold);
								spriteList[i].dy=-ABS(dxold); //-dxold
								RESTORECOORDS;
								WALLCOLLIDED;
							}
//      : ((sqr(x-BOTTOMLEFTMINX)+sqr(y-BOTTOMY))<sqrhalfballsize)
							else if ((x<BOTTOMLEFTMINX) && ((sqr(BOTTOMLEFTMINX-x))<sqrdy) && (dyold>0)) { //x<
								spriteList[i].dx=-dyold;
								spriteList[i].dy=-dxold;
								//RESTORECOORDS;
								//tmpnewy=((XTYPE)BOTTOMY<<SHIFTCOORDS)-BALLSIZE;
								WALLCOLLIDED;
							}
//      : ((sqr(x-BOTTOMRIGHTMINX)+sqr(y-BOTTOMY))<sqrhalfballsize)
							else if ((x>BOTTOMRIGHTMAXX) && ((sqr(x-BOTTOMRIGHTMAXX))<sqrdy) && (dyold>0)) { //x>
								spriteList[i].dx=dyold;
								spriteList[i].dy=dxold;
								//RESTORECOORDS;
								//tmpnewy=((XTYPE)BOTTOMY<<SHIFTCOORDS)-BALLSIZE;
								WALLCOLLIDED;
							}
//}
						}
				}

//     xleft<LEFTX (    ,    )
				if (xleft<LEFTX) {
//  : (y>LEFTMINY) && (y<LEFTMAXY) //&& (xleft<LEFTX)
					if ( (y>LEFTMINY) && (y<LEFTMAXY) ) {
						spriteList[i].dx=-dxold;
						//RESTOREX;
						tmpnewx=(XTYPE)LEFTX<<SHIFTCOORDS;
					}
//     : (y<=LEFTMINY) && ((y-x+(ballsize*7/10))>(CORNERTOP-LEFT))
					else if ( (y<=LEFTMINY) ) {
						if ( (y>(x+CORNERTOP-LEFT-(ballsize*7/10))) && (dxold<dyold) ) {
							spriteList[i].dx=dyold;
							spriteList[i].dy=dxold;
							//RESTORECOORDS;
						}
					}
//     : (y>=LEFTMAXY) && ((y+x-(ballsize*7/10))<(CORNERBOTTOM+LEFT))
					else if ( (y>=LEFTMAXY) ) {
						if ( ((y+x)<(CORNERBOTTOM+LEFT+(ballsize*7/10))) && (dxold<-dyold) ) {
							spriteList[i].dx=-dyold;
							spriteList[i].dy=-dxold;
							//RESTORECOORDS;
						}
					}
//      : ((sqr(x-LEFTX)+sqr(y-LEFTMINY))<sqrhalfballsize)
					else if (y<(LEFTMINY+ballsize)) {
							if ((((DXTYPE)sqr((DXTYPE)x-LEFTX)+sqr(LEFTMINY-(DXTYPE)y))<sqrhalfballsize) && (dxold<0)) { //y<
								spriteList[i].dx=-dyold;
								spriteList[i].dy=-dxold;
								RESTORECOORDS;
							}
					}
//      : ((sqr(x-LEFTX)+sqr(y-LEFTMAXY))<sqrhalfballsize)
					else if (y>(LEFTMAXY-ballsize)) {
							if ((((DXTYPE)sqr((DXTYPE)x-LEFTX)+sqr((DXTYPE)y-LEFTMAXY))<sqrhalfballsize) && (dxold<0)) { //y>
								spriteList[i].dx=dyold;
								spriteList[i].dy=dxold;
								RESTORECOORDS;
							}
					}
				}

//     xright>RIGHTX (    ,    )
				if (xright>RIGHTX) {
//  : (y>RIGHTMINY) && (y<RIGHTMAXY) //&& (xright>RIGHTX)
					if ( (y>RIGHTMINY) && (y<RIGHTMAXY) ) {
						spriteList[i].dx=-dxold;
						//RESTOREX;
						tmpnewx=((XTYPE)RIGHTX<<SHIFTCOORDS)-BALLSIZE;
					}
//     : (y<=RIGHTMINY) && ((y+x+(ballsize*7/10))>(CORNERTOP+RIGHT))
					else if ( (y<=RIGHTMINY) ) {
						if ( ((y+x)>(CORNERTOP+RIGHT-(ballsize*7/10))) && (dxold>-dyold) ) {
							spriteList[i].dx=-dyold;
							spriteList[i].dy=-dxold;
							//RESTORECOORDS;
						}
					}
//     : (y>=RIGHTMAXY) && ((y-x-(ballsize*7/10))<(CORNERBOTTOM-RIGHT))
					else if ( (y>=RIGHTMAXY) ) {
						if ( (y<(x+CORNERBOTTOM-RIGHT+(ballsize*7/10))) && (dxold>dyold) ) {
							spriteList[i].dx=dyold;
							spriteList[i].dy=dxold;
							//RESTORECOORDS;
						}
					}
//      : ((sqr(x-RIGHTX)+sqr(y-RIGHTMINY))<sqrhalfballsize)
					else if (y<(RIGHTMINY+ballsize)) {
							if ((((DXTYPE)sqr((DXTYPE)x-RIGHTX)+sqr(RIGHTMINY-(DXTYPE)y))<sqrhalfballsize) && (dxold>0)) { //y<
								spriteList[i].dx=dyold;
								spriteList[i].dy=dxold;
								RESTORECOORDS;
							}
					}
//      : ((sqr(x-RIGHTX)+sqr(y-RIGHTMAXY))<sqrhalfballsize)
					else if (y>(RIGHTMAXY+ballsize)) {
							if ((((DXTYPE)sqr((DXTYPE)x-RIGHTX)+sqr((DXTYPE)y-RIGHTMAXY))<sqrhalfballsize) && (dxold>0)) { //y>
								spriteList[i].dx=-dyold;
								spriteList[i].dy=-dxold;
								RESTORECOORDS;
							}
					}
				}

//    ,      ,   !
//     ( )
			spriteList[i].x=tmpnewx;
			spriteList[i].y=tmpnewy;
			//spritezones[(i<<1)+1]=(tmpnewx>>(SHIFTCOORDS+1));
			//spritezones[(i<<1)]=(tmpnewy>>(SHIFTCOORDS+1));
			_asm
/*					
			ld	a,-2 (ix)
			add	a,#<_spriteList
			ld	l,a
			adc	a,#>_spriteList
			sub	l
			ld	h,a
			ld	bc,(#_moveballs_tmpnewx_1_1+0)
			ld	(hl),c
			inc	hl
			ld	(hl),b
			inc	hl
			ld	bc,(#_moveballs_tmpnewy_1_1+0)
			ld	(hl),c
			inc	hl
			ld	(hl),b
*/
			ld	a,(#_i+0)
			add	a,a
			add	a,#<_spritezones
			ld	l,a
			adc	a,#>_spritezones
			sub	l
			ld	h,a
			ld	a,(#_moveballs_tmpnewy_1_1+1)
			ld	(hl),a
			inc	hl
			ld	a,(#_moveballs_tmpnewx_1_1+1)
			ld	(hl),a
			_endasm;

			xzone=tmpx>>(ZONESHIFT+SHIFTCOORDS);
			yzone=tmpy>>(ZONESHIFT+SHIFTCOORDS);
			//addr=ballsinzone+((u16)yzone<<8)+xzone;
			//if ( (++(*addr)) + (++(*(addr+1))) + (++(*(addr+257))) + (++(*(addr+256))) ) //      
			_asm
			ld	hl,(_moveballs_xzone_1_1)
			ld	a,(_moveballs_yzone_1_1)
			ld	h,a
			ld	bc,#_ballsinzone
			add	hl,bc
			inc (hl)
			ld	a,(hl)
			inc	l
			inc (hl)
			add	a,(hl)
			inc	h
			inc (hl)
			add	a,(hl)
			dec	l
			inc (hl)
			add	a,(hl)
			//jp	Z,skipinnerloop$
			ld (_moveballs_xzone_1_1),a
			_endasm;
			if (xzone && i)
			{
				xleft=(tmpx-BALLSIZE)>>(SHIFTCOORDS+1);
				ytop=(tmpy-BALLSIZE)>>(SHIFTCOORDS+1);

				spritezonesaddr=spritezones+i+i-1;
				//for(j=i-1; j!=-1; --j)
				j=i-1;
//				do
//				/*if (spriteList[j].exist)*/ {
				_asm
				ld a,(_xleft)
				ld (#9999491$+1),a
				ld c,a
				ld b,#0x10
				ld a,(_ytop)
				ld (#9999492$+1),a
				ld de,(_moveballs_spritezonesaddr_1_1)
				ld hl,#_j
9999499$: // 
					//if(!collided[i][j]) {
//					if ((spriteList[j].x-tmpxmin)<(BALLSIZE<<1)) {
//						if ((spriteList[j].y-tmpymin)<(BALLSIZE<<1)) {
//					if ((u8)((spriteList[j].x>>(SHIFTCOORDS+1))-xleft)<(u8)(ballsize+1)) {
//						if ((u8)((spriteList[j].y>>(SHIFTCOORDS+1))-ytop)<(u8)(ballsize+1)) {

//					if ((u8)(/*(spritezones[(j<<2)])*/(*spritezonesaddr)-xleft)<(u8)(ballsize+1)) {
				ld a,(de)
				dec de
//9999491$: // (+1)
				sub a,c //#0 //(_moveballs_xleft_1_1)
				sub	a,b //#0x10
				jp	NC,9999501$ //    
//						if ((u8)(/*(spritezones[(j<<2)+1])*/(*(spritezonesaddr+1))-ytop)<(u8)(ballsize+1)) {
				ld a,(de)
9999492$: // (+1)
				sub a,#0 //(_moveballs_ytop_1_1)
				sub	a,b //#0x10
				jp	NC,9999501$ //    
				push de //spritezonesaddr-1
				//  -     
							//dist=(SQR((ITYPE)(DXTYPE)(spriteList[i].x-spriteList[j].x))+SQR((ITYPE)(DXTYPE)(spriteList[i].y-spriteList[j].y))); //    ,    (,    )
							//if (dist < SQR((UTYPE)BALLSIZE)) {
							//if ( (sqr((DXTYPE)(spriteList[i].x-spriteList[j].x)>>SHIFTCOORDS)+sqr((DXTYPE)(spriteList[i].y-spriteList[j].y)>>SHIFTCOORDS)) < sqr(ballsize) ) {
							//if ( ((u16)sqr((DXTYPE)(spriteList[i].x-spriteList[j].x)>>(SHIFTCOORDS+1))) + ((u16)sqr((DXTYPE)(spriteList[i].y-spriteList[j].y)>>(SHIFTCOORDS+1))) < (u16)(sqrhalfballsize) ) { // 
							//if ((u8)tsqr[(i8)((DXTYPE)(tmpx-spriteList[j].x)>>5)+(128)] + (u8)tsqr[(i8)((DXTYPE)(tmpy-spriteList[j].y)>>5)+(128)] < (u8)(sqr(BALLSIZE>>5)/64) ) { //tsqr[i]=(u8)(((i-128)*(i-128))/64) //(tmpx-spriteList[j].x)>>4     
	ld	a,(hl)//(_j)
		//ld hl,#_moveballs_comparisons_1_1
		//inc (hl)
	ld	e,a
	add	a,a
	add	a,a
	add	a,e
	add	a,a
	add	a,e
	add	a,#<_spriteList
	ld	l,a
	adc	a,#>_spriteList
	sub l
	ld	h,a
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc hl
	ex de,hl
	ld hl,(#_moveballs_tmpx_1_1+0)
	or a,a //   ?
	sbc hl,bc
	push hl //tmpx-spriteList[j].x
	sra	h
	rr	l
	sra	h
	rr	l
	sra	h
	rr	l
	sra	h
	rr	l
	sra	h
	rr	l
	ex de,hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld hl,(#_moveballs_tmpy_1_1+0)
	or a,a //   ?
	sbc hl,bc
	push hl //tmpy-spriteList[j].y
	sra	h
	rr	l
	sra	h
	rr	l
	sra	h
	rr	l
	sra	h
	rr	l
	sra	h
	rr	l
	ld bc,#_tsqr+0x80
	add hl,bc
	ex de,hl
	add hl,bc
	ld a,(de)
	add a,(hl)
	pop bc //tmpy-spriteList[j].y
	pop hl //tmpx-spriteList[j].x
	//jp C,9999500$
	cp #0x38 //#0xE1
	jp NC,9999500$ //    
								//:
								//   ( 1, ..  )
//								nx=(DXTYPE)(tmpx-spriteList[j].x)/(BALLSIZE>>4);
	push bc
	push	bc
	ld	de,#0x0078
	push	de
	push	hl //tmpx-spriteList[j].x
	call	__divsint_rrx_s
	pop	af
	pop	af
	pop	bc
	ld	(_moveballs_nx_1_1 + 0),hl
//								ny=(DXTYPE)(tmpy-spriteList[j].y)/(BALLSIZE>>4);
	pop hl
	push	bc
	ld	de,#0x0078
	push	de
	push	hl //tmpy-spriteList[j].y
	call	__divsint_rrx_s
	pop	af
	pop	af
	pop	bc
	ld	(_moveballs_ny_1_1 + 0),hl
_endasm;
								//,    ( V, .. (nx,xy)  )
								//  16*16=>32  8.8*8.8=>8.8
								p=DOTPRODUCT((spriteList[i].dx-spriteList[j].dx),
											(spriteList[i].dy-spriteList[j].dy),
											nx,
											ny)>>(4+4);
											///(ITYPE)BALLSIZE; // UTYPE - ?
								//if (p>0) p=-p;
								if (p<0) { //       
								// ,    ( V)
								px=(p*nx);
								///(ITYPE)BALLSIZE; // UTYPE - ?
								py=(p*ny);
								///(ITYPE)BALLSIZE; // UTYPE - ?
								//  ( V)
								spriteList[i].dx-=px;
								#ifdef CHECKMAXSPEED
								if (spriteList[i].dx >= MAXSPEED) spriteList[i].dx = MAXSPEED;
								if (spriteList[i].dx < -MAXSPEED) spriteList[i].dx = -MAXSPEED;
								#endif
								spriteList[i].dy-=py;
								#ifdef CHECKMAXSPEED
								if (spriteList[i].dy >= MAXSPEED) spriteList[i].dy = MAXSPEED;
								if (spriteList[i].dy < -MAXSPEED) spriteList[i].dy = -MAXSPEED;
								#endif
								spriteList[j].dx+=px;
								#ifdef CHECKMAXSPEED
								if (spriteList[j].dx >= MAXSPEED) spriteList[j].dx = MAXSPEED;
								if (spriteList[j].dx < -MAXSPEED) spriteList[j].dx = -MAXSPEED;
								#endif
								spriteList[j].dy+=py;
								#ifdef CHECKMAXSPEED
								if (spriteList[j].dy >= MAXSPEED) spriteList[j].dy = MAXSPEED;
								if (spriteList[j].dy < -MAXSPEED) spriteList[j].dy = -MAXSPEED;
								#endif
//      , .. dx     < dx , dy  < dy 

		//spriteList[i].dx=rand16()%(2<<SHIFTCOORDS)-(1<<SHIFTCOORDS); //rand16()&1?-1:1;
		//spriteList[i].dy=rand16()%(2<<SHIFTCOORDS)-(1<<SHIFTCOORDS); //rand16()&1?-1:1;
		//spriteList[j].dx=rand16()%(2<<SHIFTCOORDS)-(1<<SHIFTCOORDS); //rand16()&1?-1:1;
		//spriteList[j].dy=rand16()%(2<<SHIFTCOORDS)-(1<<SHIFTCOORDS); //rand16()&1?-1:1;
								//spriteList[i].color=(spriteList[i].color+1)&3;
								//spriteList[j].color=(spriteList[j].color+1)&3;
								//collided[i][j]=5;
								}
							//}
						//}
					//}
					_asm
9999500$: //    
					pop de //spritezonesaddr-1
					ld	hl,#_j
9999491$: // (+1=c)
					ld bc,#0x1000 //(_moveballs_xleft_1_1)
9999501$: //    
					//spritezonesaddr-=2;
					dec de
					//}//else collided[i][j]--;
					//ld	hl,#_j
					//inc	(hl)
					//ld	a,(_i)
					//sub	a,(hl)
					//jp	NZ,9999499$
					dec (hl)
					jp	P,9999499$ // 
					_endasm;
//				} while ((--j) != -1); //j
			} //ballsinzone
/**/
			} //i //sprites

			// 
			for(i=0;i<SPRITES_ALL;++i) if (spriteList[i].exist) {
				xzone=spriteList[i].x>>(ZONESHIFT+SHIFTCOORDS);
				yzone=spriteList[i].y>>(ZONESHIFT+SHIFTCOORDS);
			//addr=ballsinzone+((u16)yzone<<8)+xzone;
			//( (++(*addr)); (++(*(addr+1))); (++(*(addr+257))); (++(*(addr+256))) );
			_asm
				ld	hl,(_moveballs_xzone_1_1)
				ld	a,(_moveballs_yzone_1_1)
				ld	h,a
				ld	bc,#_ballsinzone
				add	hl,bc
				ld a,#-1
				ld (hl),a
				inc	l
				ld (hl),a
				inc	h
				ld (hl),a
				dec	l
				ld (hl),a
			_endasm;
			}
}




void main(void)
{
	static DXTYPE vx,vy;
	static XTYPE len;
	static XTYPE tryx,tryy;
	static u8 xzone,yzone;
	static i16 cur_place,cur_speed;
#define CUR_BRIM (2) /*       */
#define CUR_SIZE (7) /*   */
#define CUR_XPERIOD (RIGHT-BRIM-SCRSHIFTX + CUR_BRIM - (LEFT+BRIM-SCRSHIFTX - CUR_BRIM-CUR_SIZE))
#define CUR_YPERIOD (BOTTOM-BRIM-SCRSHIFTY + CUR_BRIM - (TOP+BRIM-SCRSHIFTY - CUR_BRIM-CUR_SIZE))
#define CUR_PERIOD ((CUR_XPERIOD+CUR_YPERIOD)*2)
	static u16 cur_x,cur_y;
	static u8 cur_xscr;
	static u8 palette[16];
	static u8 curtime,oldtime,logictime,logicframe;
	static u8 ingame;
	static u8 power;

	//    

	pal_bright(BRIGHT_MIN);

	i=0; do { tsqr[i]=(u8)(((i-128)*(i-128))/64); ++i; } while (i!=0);
	
	//  

	//for(i=0;i<SPRITES_ALL;++i) for(j=0;j<SPRITES_ALL;++j) collided[i][j]=0;

	for(i=0;i<SPRITES_ALL;++i)
	{
		spriteList[i].x=RNDLEFTMARGIN+(((u32)rand16()<<16)+rand16())%((u32)(RNDRIGHTMARGIN-RNDLEFTMARGIN));
		spriteList[i].y=RNDTOPMARGIN+(((u32)rand16()<<16)+rand16())%((u32)(RNDBOTTOMMARGIN-RNDTOPMARGIN));
		//while(spriteList[i].y>=RNDBOTTOMMARGIN){};
		spriteList[i].dx=0;
		spriteList[i].dy=0;
		spriteList[i].color=i?(i&3):4;
		spriteList[i].exist=1;
		spriteList[i].wallcollided=0;
	}

	for(i=0;i<SPRITES_ALL;++i)
	{
		spriteList[i].dx=((ITYPE)((((u32)rand16()<<16)+rand16())%((u32)8<<SHIFTCOORDS))-((u32)4<<SHIFTCOORDS))/2; //rand16()&1?-1:1;
		spriteList[i].dy=((ITYPE)((((u32)rand16()<<16)+rand16())%((u32)8<<SHIFTCOORDS))-((u32)4<<SHIFTCOORDS))/2; //rand16()&1?-1:1;
	}

	for(xzone=0;xzone<XZONES;++xzone) for(yzone=0;yzone<YZONES;++yzone) ballsinzone[((u16)yzone<<8)+xzone]=-1;

	//    

	draw_image(0,0,IMG_BACK);
	pal_select(PAL_BACK);

	// ,     

	swap_screen();

	// 

	sprites_start();

	// ,      
	// 0..5  ,  6..15  
	//pal_copy(PAL_BACK,palette);
	//for(i=0;i<6;++i) pal_col(i,palette[i]);
	//pal_copy(PAL_BALLS,palette);
	//for(i=6;i<16;++i) pal_col(i,palette[i]);

	//  

	pal_bright(BRIGHT_MID);

	// 
#define SPRITE_CUR 32
while(1) {
	prnum(0,0,0/*power*/);
	ingame=0;
	cur_speed=0;
	cur_place=CUR_YPERIOD/2; //      
	//
	while(!ingame) {
		//  
		j=0;
		draw_sprites();
		
		//cur_x=LEFT+BRIM-SCRSHIFTX - CUR_BRIM-CUR_SIZE;
		//cur_x=RIGHT-BRIM-SCRSHIFTX + CUR_BRIM;
		//cur_y=100;
		//      
		if (cur_place<CUR_YPERIOD) { // 
			cur_x=RIGHT-BRIM-SCRSHIFTX + CUR_BRIM;
			cur_y=(TOP+BRIM-SCRSHIFTY -9 - CUR_BRIM-CUR_SIZE) + cur_place;
		}
		else if (cur_place<(CUR_YPERIOD+CUR_XPERIOD)) { //  ( )
			cur_x=(RIGHT-BRIM-SCRSHIFTX + CUR_BRIM) - (cur_place-CUR_YPERIOD);
			cur_y=BOTTOM-BRIM-SCRSHIFTY -9 + CUR_BRIM;
		}
		else if (cur_place<(CUR_YPERIOD+CUR_XPERIOD+CUR_YPERIOD)) { //  ( )
			cur_x=LEFT+BRIM-SCRSHIFTX - CUR_BRIM-CUR_SIZE;
			cur_y=(BOTTOM-BRIM-SCRSHIFTY -9 + CUR_BRIM) - (cur_place-(CUR_YPERIOD+CUR_XPERIOD));
		}
		else { // 
			cur_x=(LEFT+BRIM-SCRSHIFTX - CUR_BRIM-CUR_SIZE) + (cur_place-(CUR_YPERIOD+CUR_XPERIOD+CUR_YPERIOD));
			cur_y=TOP+BRIM-SCRSHIFTY -9 - CUR_BRIM-CUR_SIZE;
		}
		
		cur_xscr=(cur_x>>1);
		set_sprite(j++,(cur_xscr>(160-8))?cur_xscr-4:cur_xscr,cur_y,SPRITE_CUR|((cur_x&1)?16:0)|((cur_xscr>(160-8))?1:0));
		set_sprite(j,0,0,SPRITE_END);

		//  
		keyboard(keys);
		vsync(); //for joystick
		joy=joystick();

		//if(gameover==0)
		{
			if(joy&JOY_FIRE) { joy=JOY_FIRE; ingame=1;}
			if(joy&JOY_LEFT) { joy=JOY_LEFT; cur_speed++; if (cur_speed<8)cur_speed=8; cur_place-=(cur_speed/8);}
			if(joy&JOY_RIGHT) { joy=JOY_RIGHT; cur_speed++; if (cur_speed<8)cur_speed=8; cur_place+=(cur_speed/8);}
			if(!(joy&(JOY_LEFT|JOY_RIGHT))) cur_speed=0;
			if (cur_place<0) cur_place+=CUR_PERIOD;
			if (cur_place>=CUR_PERIOD) cur_place-=CUR_PERIOD;
			//if(joy&JOY_UP) { joy=JOY_UP; move_up();}
			//if(joy&JOY_DOWN) { joy=JOY_DOWN; move_down();}

			// 
			//if(joy==0) put_board();

			//if (check_gameover()!=0) do_gameover();

			//if (win==1) {win++; do_win();};
		}

		//if(keys[KEY_R]&KEY_PRESS) new_game();
		swap_screen();
	}

	// 
	power=0;
	do {
		//  
		keyboard(keys);
		vsync(); //for joystick
		joy=joystick();
		if(joy&JOY_FIRE) { power=(power+1)&127;} else ingame=2;
		prnum(0,0,power);
		swap_screen();
	
	}while(ingame!=2);
	i = 0;
// =   * power
	vx = (DXTYPE)((DXTYPE)(cur_x+SCRSHIFTX)<<SHIFTCOORDS)-spriteList[i].x;
	vy = (DXTYPE)((DXTYPE)(cur_y+SCRSHIFTY)<<SHIFTCOORDS)-spriteList[i].y;
	//prnum(1,0,vx);
	//prnum(1,10,vy);
	len = lsqrt(SQR(ABS(vx)) + SQR(ABS(vy)));
	vx = (ITYPE)vx * power / len;
	vy = (ITYPE)vy * power / len;
	spriteList[i].dx=vx<<3;
	spriteList[i].dy=vy<<3;

	//  
	for(i=1;i<SPRITES_ALL;++i) {
		spriteList[i].dx=0;
		spriteList[i].dy=0;
	}

	oldtime = time()-1;
	// 
	do {
		//  
		j=0;
		draw_sprites();
		set_sprite(j,0,0,SPRITE_END);

		// 
		curtime = time();
		logictime = curtime-oldtime;
		oldtime = curtime;
		for (logicframe = 0 ; logicframe < logictime; logicframe++)
		{
			//comparisons=0;
			moveballs();

		} //logicframes
		//spritezonesaddr+=2; //  ,       ( )

		//prnum(0,0,comparisons);
		//przones(1,0);
		//prnum(2,0,xshow);
		//prnum(2,10,yshow);
		
		// ,   
		swap_screen();
	}while(movingballs);
	
	//

	//  ,   
	if (!(spriteList[0].exist))
	{
		spriteList[0].exist=1;
		tryx=(LEFT+64)<<SHIFTCOORDS;
		tryy=((TOP+(BOTTOM-ballsize))/2)<<SHIFTCOORDS;
		do {
			ingame=0;
			for (i=1;i<SPRITES_ALL;++i) if(spriteList[i].exist) {
				if( ((spriteList[i].x-(tryx-BALLSIZE))<(BALLSIZE*2))
				 && ((spriteList[i].y-(tryy-BALLSIZE))<(BALLSIZE*2)) ) ingame=1; //
			}
			if (ingame) { // -   
				tryy+=(16<<SHIFTCOORDS);
				if (tryy > (((TOP+(BOTTOM-ballsize))/2+50)<<SHIFTCOORDS) ) {
					tryy=((TOP+(BOTTOM-ballsize))/2-50)<<SHIFTCOORDS;
					tryx+=(16<<SHIFTCOORDS);
				}
			}
		} while (ingame!=0);
		spriteList[0].x=tryx;
		spriteList[0].y=tryy;
	}
	
}
}